#include "stdafx.h"
#include "MyApplication.h"
#include "MyData.h"
#include "MyWindow.h"


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyApplication::CMyApplication() : CMyObject()
{
	InitApp();
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyApplication::CMyApplication(HINSTANCE hInstance) : CMyObject()
{
	InitApp();

	m_hInstance	= hInstance;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMyApplication::InitApp()
{
	m_pWindow			= NULL;
	m_pData				= NULL;
	m_hInstance			= NULL;	

	// ulozeni pointeru na aplikaci do zakladni tridy okna
	CMyWindowObject::SetApplication(this);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyApplication::~CMyApplication()
{
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyApplication::Inicialization(HINSTANCE hInstance)
{
	// Ulozeni instance aplikace, pokud jiz nebyla ulozena 
	if (hInstance != NULL) m_hInstance = hInstance;
	if (m_hInstance == NULL) {
		assert(0);
		return(FALSE);
	}
	// Data nemusi byt soucasti aplikace
	m_pData = InitData();

	if ((m_pData != NULL) && (!m_pData->InitData())) {
		OutputDebugString(L"Nepodarilo se inicializovat datove slozky instanci tridy CMyData nebo nejakeho jeho potomka!");
		assert(0);
		return(FALSE);
	}
	// Okno MUSI byt soucasti aplikace
	if ((m_pWindow = InitWindow()) == NULL) {
		OutputDebugString(L"Pointer na instanci tridy CMyWindow je NULL\n");
		assert(0);
		return(FALSE);
	}

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HINSTANCE CMyApplication::GetSaveInstance()
{
	if (this == NULL) return(NULL);
	return(m_hInstance);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyWindow* CMyApplication::GetSaveWindow()
{
	if (this == NULL) return(NULL);
	return(m_pWindow);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyData* CMyApplication::GetSaveData()
{
	if (this == NULL) return(NULL);
	return(m_pData);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyData* CMyApplication::InitData()
{
	return(NULL);
}