#ifndef MyApplicationH
#define MyApplicationH


#include <windows.h>
#include "MyObject.h"

class CMyWindow;
class CMyData;

/** Tda CMyApplication je tda obecn aplikace.
	Aplikace v sob zahrnuje pointer na instanci tdy okna (pohledu)
	jako potomka CMyWindow, co me bt jak klasick okno tak dialogov
	okno a pointer na instanci tdy dat jako potomka tdy CMyData.
	Tda je abtraktn, obsahuje ist virtuln metody, a proto nen
	mon vytvoit instanci tto tdy. Tda je urena k ddn,
	jej potomek mus implementovat minimln ve zmnn metody, kter
	jsou ureny k vytvoen instance tdy okna a k jeho zobrazen.
	Dle je mon implementovat virtuln metodu pro inicializaci
	instance vlastn datov tdy jako potomka CMyData.
	Tda samotn jet uchovv handle instance aplikace. Dle je pointer
	na instanci tto tdy (tzn. pointer na samotnou aplikaci) pedn
	td okna (pohledu) CMyWindow a tm inicializovn statick atribut
	tto tdy, co umon, aby kad instance tdy CMyWindow nebo jeho
	potomk mla pstup k samotn aplikaci. Typick pklad aplikace:
	
	CSubtitleRepairApp	hApp;
	HACCEL					hAccelTable;
	MSG						sMessage;

	hApp.Inicialization(hInstance);
	hApp.ShowApplicationWindow();

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_ACCELERATORS));
   // Hlavni smycka zprav
	while (GetMessage(&sMessage, NULL, 0, 0)) {
		if (!TranslateAccelerator(sMessage.hwnd, hAccelTable, &sMessage)) {
			TranslateMessage(&sMessage);
			DispatchMessage(&sMessage);
		}
	}

	*/
class __declspec(dllexport) CMyApplication : public CMyObject {
//Konstruktory a destruktor
public:
	/** Destruktor*/
	virtual ~CMyApplication();

protected:
	/** Implicitn konstruktor*/
	CMyApplication();
	/** Konstruktor (HINSTANCE)*/
	CMyApplication(HINSTANCE hInstance);

private:



//Funkce a metody
public:
	/** Inicializace aplikace.<BR>
		Provede se celkov inicializace aplikace. Nejprve je otestovna pedan
		handle instance, zda-li nen NULL. Dle je volna virtuln funkce na
		inicializaci instance tdy dat (InitData), nsledn na je volna funkce
		na inicializaci tdy pohledu (InitWindow) a jako posledn se ulo handle
		instance a ped se pointer na aplikaci tdm okna (pohledu). Pokud dojde
		pi inicializaci k chyb vrt FALSE, jinak - pi spchu - vrt TRUE.<BR>
		@param hInstance ... handle instance aplikace, nesm bt NULL*/
	BOOL						Inicialization(HINSTANCE hInstance);
	/** Data aplikace.<BR>
		Vrt pointer na data aplikace. To me bt instance tdy CMyData nebo
		njakho jejho potomka. Jedn se o 'bezpenou' funkci, kter pi nevytvoen
		instanci tdy aplikace vrac NULL.*/
	CMyData*					GetSaveData();
	/** Hlavn okno aplikace.<BR>
		Vrt pointer na hlavn okno aplikace. To me bt instance tdy CMyWindow
		nebo njakho jejho potomka, tzn. i na instanci tdy njakho dialogu, pokud
		je dialog hlavn oknem tto aplikace. Jedn se o 'bezpenou' funkci, kter
		pi nevytvoen instanci tdy aplikace vrac NULL.*/
	CMyWindow*				GetSaveWindow();
	/** Handle instance aplikace.<BR>
		Vrt handle instance aplikace. Tento handle je pouze jeden pro kadou
		aplikaci. Jedn se o 'bezpenou' funkci, kter pi nevytvoen instanci
		tdy aplikace vrac NULL.*/
	HINSTANCE				GetSaveInstance();
	/** Zobrazen hlavnho okna aplikace.<BR>
		ist virtuln metoda, kter mus bt v dcein td implementovna. Jejm
		zavolnm se hlavn okno aplikace zobrazuje tzn., e vlastn implementace
		by mla obsahovat nezbytn kroky pro zobrazen hlavnho okna aplikace.
		Instance hlavnho okna aplikace je inicializovna prostednictvm funkce
		InitWindow. Nvratov hodnota by mla odpovdat zvyklostem, pi spnm
		zobrazen TRUE a pi chyb pi zobrazen hlavnho okna aplokace pak FALSE.*/
	virtual BOOL			ShowApplicationWindow() = 0;

protected:
	
private:
	/** Inicializace aplikace.*/
	void						InitApp();
	/** Inicializace instance dat aplikace.<BR>
		Virtuln metoda pro inicializaci instance dat aplikace. Funkce vrac pointer
		na instanci tdy CMyData (nebo njak jej dcein tdy). Pi implementaci
		v dcein td umouje inicializaci instance vlastn dcein tdy jako
		potomka CMyData. Pokud nen implentovna, provede se inicializace instance
		tdy CMyData. Pokud nen datov st aplikace poteba me vracet NULL,
		ale nen to doporueno.*/
	virtual CMyData*		InitData();
	/** Inicializace instance hlavnho okna aplikace.<BR>
		ist virtuln metoda pro inicializaci instance hlavnho okna aplikace. Funkce
		vrac	pointer na instanci tdy CMyWindow (astji spe njak jej dcein tdy).
		Je nutn ji implemntovat v dcein td nebo CMyWindow neumouje vytvet instance.
		Nesm vrtit NULL, nebo 'okenn 'aplikace potebuje alespo jedno okno k ivotu. */
	virtual CMyWindow*	InitWindow() = 0;




//Atributy a datove cleny
public:

protected:
	/** Pointer na hlavn okna aplikace */
	CMyWindow*				m_pWindow;
	/** Pointer na data aplikace */
	CMyData*					m_pData;
	/** Handle instance aplikace */
	HINSTANCE				m_hInstance;

private:	

};

#endif


//Vygenerovno prostrednictvm ClassGen 1.10.001