#include "stdafx.h"
#include "MyWindowObject.h"
#include "MyApplication.h"


CMyApplication*	CMyWindowObject::m_pApplication	= NULL;


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyWindowObject::CMyWindowObject() : CMyObject()
{
	m_hWnd = NULL;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyWindowObject::~CMyWindowObject()
{
	DestroyWindow();
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
void CMyWindowObject::SetApplication(CMyApplication* pApplication)
{
	m_pApplication = pApplication;
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
CMyApplication* CMyWindowObject::GetSaveApplication()
{
	if (this == NULL) return(NULL);
	return(m_pApplication);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
HWND CMyWindowObject::GetSafeHandle()
{
	if (this == NULL) return(NULL);
	return(m_hWnd);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyWindowObject::SaveHandle(HWND hWnd)
{
	if (hWnd == NULL) return(FALSE);

	if (!::IsWindow(hWnd)) return(FALSE);

	m_hWnd = hWnd;

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyWindowObject::UpdateWindow()
{
	if (m_hWnd == NULL) return(FALSE);

	return(::UpdateWindow(m_hWnd));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyWindowObject::GetClientRect(RECT *pRect)
{
	if ((m_hWnd == NULL) || (pRect == NULL))
		return(FALSE);
	else return(::GetClientRect(m_hWnd, pRect));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
int CMyWindowObject::MessageBox(LPCWSTR pwzMessage, LPCWSTR pwzTitle, UINT nType)
{
	if ((m_hWnd == NULL) || (pwzMessage == NULL))
		return(-1);

	return(::MessageBox(m_hWnd, pwzMessage, pwzTitle, nType));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyWindowObject::DestroyWindow()
{
	if (m_hWnd == NULL) return(FALSE);
	if (::DestroyWindow(m_hWnd)) {
		m_hWnd = NULL;
		return(FALSE);
	}
	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyWindowObject::ShowWindow(int nCmdShow)
{
	return(Show(nCmdShow));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyWindowObject::Show(int nCmdShow)
{
	if (m_hWnd == NULL) return(FALSE);

	::ShowWindow(m_hWnd, nCmdShow);
	
	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
BOOL CMyWindowObject::EnableWindow(BOOL bEnable)
{
	if (m_hWnd == NULL) return(FALSE);

	::EnableWindow(m_hWnd, bEnable);

	return(TRUE);
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
LONG CMyWindowObject::SetWindowLong(int nIndex, LONG lNewValue)
{
	if (m_hWnd == NULL) return(0);

	return(::SetWindowLong(m_hWnd, nIndex, lNewValue));
}

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
LONG CMyWindowObject::GetWindowLong(int nIndex)
{
	if (m_hWnd == NULL) return(0);

	return(::GetWindowLong(m_hWnd, nIndex));
}