#ifndef MyWindowObjectH
#define MyWindowObjectH


#include <windows.h>
#include "MyObject.h"


class CMyApplication;


/** Tda CMyWindowObject je tda nad handlem okna (HWND)
	a zahrnuje vechny operace, kter ke sv inosti potebuj handle. */
class __declspec(dllexport) CMyWindowObject : public CMyObject {
//Konstruktory a destruktor
public:
	/** Implicitn konstruktor*/
	CMyWindowObject();
	/** Destruktor*/
	virtual ~CMyWindowObject();

protected:

private:



//Funkce a metody
public:
	/** Zruen okna. */
	BOOL								DestroyWindow();
	/** Zskn uloenho HWND. */
	HWND								GetSafeHandle();
	/** Aktualizace okna. */
	BOOL								UpdateWindow();
	/** Zskn rozmr klientsk sti okna. */
	BOOL								GetClientRect(RECT* pRect);
	/** Zobrazen dialogu se zprvou. */
	int								MessageBox(LPCWSTR pwzMessage, LPCWSTR pwzTitle = NULL, UINT nType = MB_OK);	
	/** Zobrazen okna. */
	BOOL								Show(int nCmdShow = SW_SHOW);
	/** Zobrazen okna. */
	BOOL								ShowWindow(int nCmdShow);
	/** Povolen/zakzn okna. */
	BOOL								EnableWindow(BOOL bEnable);
	/** Zskn atribut okna. */
	LONG								GetWindowLong(int nIndex);
	/** Nastaven atribut okna. */
	LONG								SetWindowLong(int nIndex, LONG lNewValue);

protected:
	/** Zskn pointeru na uloenou aplikaci. */
	CMyApplication*				GetSaveApplication();

private:
	/** Uloen HWND. */
	BOOL								SaveHandle(HWND hWnd);
	/** Uloen pointeru na aplikaci. */
	static void						SetApplication(CMyApplication* pApplication);



//Atributy a datove cleny
public:

protected:
	/** HWND okna.*/
	HWND								m_hWnd;

private:
	/** Pointer na aplikaci. */
	static CMyApplication*		m_pApplication;


friend class CMyApplication;
friend class CMyWindow;

};

#endif
